SB.events = {};

function SB.events.OnLoad( this )
	this:RegisterForClicks( "LeftButton", "RightButton" );
	
	this:RegisterEvent("VARIABLES_LOADED");
	this:RegisterEvent("SAVE_VARIABLES");
	this:RegisterEvent("SKILL_UPDATE");
	this:RegisterEvent("TP_EXP_UPDATE");
	this:RegisterEvent("PLAYER_LEVEL_UP");
end;

function SB.events.OnEvent( this, event )
	if( event == "VARIABLES_LOADED" )then
		SB.events.VariablesLoaded();
	end;
	if( event == "TP_EXP_UPDATE" )then
		SB.events.TryAutoIncrease();
	end;
end;

function SB.events.VariablesLoaded()
	SB.PANIC = false;
	local hRet;
	hRet, SBVariables = MLib.CheckVariables( SBVariables, SB.DefaultConfig );
	if( hRet == MLIB_CHECKVARIABLES_FAILED )then
		SB.Message( "|cffFF0000Ошибка запуска! Исполнение прекращено!|r" );
		SB.PANIC = true;
		return nil;
	end;
	SaveVariables( "SBVariables" );
	
	local _scale = GetUIScale();

	SB.Message( SB.Name .. " " .. SB.Version .. " успешно загружен" );
	
	if( SBVariables.Frame ~= nil )then
		MSkillBookFrame:ClearAllAnchors();
		MSkillBookFrame:SetAnchor( "TOPLEFT", "TOPLEFT", UIParent, SBVariables.Frame.X / _scale, SBVariables.Frame.Y / _scale );
	end;
	
	SB.Inited = true;
end;

function SB.events.TryAutoIncrease()
	local skills = SBVariables.AI[ UnitClassToken( "player" ) ];
	for p = 2, 4, 2 do
		for n = 1, GetNumSkill( p ) do
			local id = p .. ":" .. n;
			if( skills[ id ] )then
				-- try
				local _SkillName, _SkillLV, _IconPath, _Mode, _PLV, _PPoint, _PTotalPoint, _EnableToLV, _bLearned = GetSkillDetail( p, n );
				
				local Remain		= nil;

				if( _EnableToLV == 0 and _PLV == 0 and _PPoint == 0 and _PTotalPoint == 0 )then
					_EnableToLV = nil;
					_PLV = nil;
					_PPoint = nil;
					_PTotalPoint = nil;
				end

				if( _PTotalPoint ) then
					--Percent = _Point / _TotalPoint;
					Remain = _PTotalPoint - _PPoint;
				end
				
				if( Remain )then
					if( Remain <= GetTpExp() )and( _EnableToLV ~= 0 )then
						SetSpellPoint( p, n ); 
						SB.Message( 'Уровень скилла "' .. _SkillName .. '" повышен до +' .. ( _PLV + 1 ) );
					end;
				end;
				--return nil;
			end;
		end;
	end;
end;

function SB.events.ShowHint( this )
	MLib.TT.Init( this, SB.Name .. " " .. SB.Version, 300, "ANCHOR_TOPLEFT", 0, 0 );
	MLib.TT.Space();
	MLib.TT.LineEx( "", SBVariables.Enabled, MLib.YESPattern:format( "Включен!" ), MLib.NOPattern:format( "Выключен" ) );
	MLib.TT.LineEx( "Заменять книгу скиллов: ", SBVariables.ExtraSkillBook, MLib.YESPattern:format( "да" ), MLib.NOPattern:format( "нет" ) );
	MLib.TT.Space();
	MLib.TT.Line( UI_MINIMAPBUTTON_MOVE, 0, 0.75, 0.95 );
end;

function SB.events.HideHint( this )
	MLib.TT.Hide();
end;

function SB.events.OnUpdateMinimapButton( this, elapsedTime )
end;

function SB.events.PaintSkillButton( buttonName, p, n )
	local _SkillName, _SkillLV, _IconPath, _Mode, _PLV, _PPoint, _PTotalPoint, _EnableToLV, _bLearned = GetSkillDetail( p, n );
	local _duration, _remaining = GetSkillCooldown( p, n );
	local _Button = _G[ buttonName ];
	local _ButtonName	= buttonName;
	local _SkillInfoName	= _ButtonName .. "_SkillInfo";
	local _ItemButton	= getglobal( _ButtonName .. "ItemButton" );
	local _Name		= getglobal( _SkillInfoName .. "_Name"	);
	local _LV		= getglobal( _SkillInfoName .. "_LV"	);
	local _PowerLV		= getglobal( _ButtonName .. "PowerLV"	);
	local _StatusBar	= getglobal( _ButtonName .. "PointStatusBar" );
	local _NextValue	= getglobal( _ButtonName .. "PointStatusBar" .. "NextValue" );
	local _NextValueTitle	= getglobal( _ButtonName .. "PointStatusBar" .. "Next" );
	local _PowerIcon	= getglobal( _ButtonName .. "Icon" );	
	
	_Button.Page = p;
	_Button.Index = n;
	
	if( _SkillName ) then
		_NextValueTitle:Show();
		_Button:Enable();
	else
		_NextValueTitle:Hide();
		_Button:Disable();
	end

	local Remain		= nil;

	if( _EnableToLV == 0 and _PLV == 0 and _PPoint == 0 and _PTotalPoint == 0 )then
		_EnableToLV = nil;
		_PLV = nil;
		_PPoint = nil;
		_PTotalPoint = nil;
	end

	if( _PTotalPoint ) then
		--Percent = _Point / _TotalPoint;
		Remain = _PTotalPoint - _PPoint;
	end
	if( Remain ) then 
		_NextValue:SetText( MLib.ThSeparator( Remain ) ); 
		if( Remain <= GetTpExp() )then
			_NextValue:SetColor( 0.2, 0.7, 0.2 );
		else
			_NextValue:SetColor( 0.7, 0.7, 0.2 );
		end;
	else 
		_NextValue:SetText( "" ); 
	end

	getglobal( _ButtonName .. "PointStatusBar" .. "StatusText" ):Hide();

	SetItemButtonTexture( _G[ buttonName .. "_Icon" ], _IconPath );
	_Name:SetText( _SkillName );
	_LV:SetText( "" );
	CooldownFrame_SetTime( _G[ buttonName .. "_IconCooldown" ], _duration, _remaining);
	if( _PLV and _PLV > 0 ) then
		local strRank = TEXT( "SYS_MAGIC_LEVEL" )
		_LV:SetText( strRank .. _PLV );	
		_LV:SetColor( 0.9, 0.9, 0.4 );
	else	
		_LV:SetText( "" );	
	end
	if( _PLV ) then 
		_PowerLV:SetText( _PLV );
		_NextValue:Show();
		_PowerIcon:Show();
	else 
		_NextValue:Hide();
		_PowerLV:SetText( "" );
		_PowerIcon:Hide();			
	end

	_G[ _SkillInfoName .. "AutoIncrease" ]:Hide();
	if( _EnableToLV ) then
		_StatusBar:Show();
		if( _EnableToLV == 0 ) then
			_StatusBar:SetValue( 1 );
			_NextValue:SetText( "" );
			getglobal( _ButtonName .. "PointStatusBar" .. "Next" ):Hide();
			getglobal( _ButtonName .. "PointStatusBar" .. "StatusText" ):Show();
		else
			_StatusBar:SetValue( _PLV / UnitLevel( "player" ) );				
			getglobal( _ButtonName .. "PointStatusBar" .. "Next" ):Show();
			getglobal( _ButtonName .. "PointStatusBar" .. "StatusText" ):Hide();
		end
		local id = _Button.Page .. ":" .. _Button.Index;
		local ntex = _G[ _SkillInfoName .. "AutoIncrease" ]:GetNormalTexture();
		local ptex = _G[ _SkillInfoName .. "AutoIncrease" ]:GetPushedTexture();
		if( SBVariables.AI[ UnitClassToken( "player" ) ] == nil )then SBVariables.AI[ UnitClassToken( "player" ) ] = {}; end;
		if( SBVariables.AI[ UnitClassToken( "player" ) ][ id ] == nil )then
			ntex:SetTexture( "interface/addons/mskillbook/texture/unchecked" );
			ptex:SetTexture( "interface/addons/mskillbook/texture/unchecked" );
		else
			ntex:SetTexture( "interface/addons/mskillbook/texture/checked" );
			ptex:SetTexture( "interface/addons/mskillbook/texture/checked" );
		end;
		_G[ _SkillInfoName .. "AutoIncrease" ]:Show();
		_StatusBar:Show();
	else
		_StatusBar:Hide();
	end

	if( _Mode == 0 or _Mode == 1 )then
		_Name:SetText( _SkillName );
		_Name:SetColor( 1, 1, 1 );
	elseif( _Mode == 2 ) then
		_Name:SetColor( 0.1, 0.68, 0.21 );
		_Name:SetText( _SkillName );
	elseif( _Mode == 100 ) then	
		_Name:SetText( _SkillName );
		_Name:SetColor( 1, 1, 1 );
	else
		_Name:SetText( _SkillName );
		_Name:SetColor( 1, 1, 1 );
	end
end;

function SB.events.BookOnShow( this )
	local class, subclass = UnitClass( "player" );
	local c, sc = UnitClassToken( "player" );
	_G[ this:GetName() .. "Tabs" ].Tabs = {
		[1]	= {
			["Name"] = "Общие",
			["Hint"] = "Общие скиллы",
			["Icon"] = nil,
			["Size"] = 100,
		},
		[2]	= {
			["Name"] = class,
			["Hint"] = "Скиллы доступные для класса " .. class .. ", так же доступны, если " .. class .. " будет дополнительным классом",
			["Icon"] = MLib.ClassIcon[c],
			["Size"] = 100,
		},
		[3]	= {
			["Name"] = subclass,
			["Hint"] = "Скиллы доступные для класса " .. subclass .. ", так же доступны, если " .. subclass .. " будет дополнительным классом",
			["Icon"] = MLib.ClassIcon[sc],
			["Size"] = 100,
		},
		[4]	= {
			["Name"] = "Только для " .. class,
			["Hint"] = "Скиллы доступные только если класс " .. class .. " будет основным",
			["Icon"] = MLib.ClassIcon[c],
			["Size"] = 100,
		},
	};
	_G[ this:GetName() .. "Title" ]:SetText( "Навыки" );

	if( SB.events.Placed ~= true )then
		for p = 1, 4 do
			local skill = this:GetName() .. "Page" .. p .. "ScrollFrameContainer" .. "Skill";
			_G[ skill .. "1" ]:ClearAllAnchors();
			_G[ skill .. "1" ]:SetAnchor( "TOPLEFT", "TOPLEFT", "$parent", 5, 0 );
			

			_G[ skill .. "2" ]:ClearAllAnchors();
			_G[ skill .. "2" ]:SetAnchor( "TOPLEFT", "TOPRIGHT", skill .. "1", 5, 0 );
			
			for n = 3, 80 do
				_G[ skill .. n ]:ClearAllAnchors();
				_G[ skill .. n ]:SetAnchor( "TOPLEFT", "BOTTOMLEFT", skill .. ( n - 2 ), 0, 5 );
			end;
			
			for n = 1, 80 do
				if( n <= GetNumSkill( p ) )then
					_G[ skill .. n ]:Show();
					SB.events.PaintSkillButton( skill .. n, p, n )
				else
					_G[ skill .. n ]:Hide();
				end;
			end;
			
			local count = GetNumSkill( p );
			if( math.fmod( count, 2 ) ~= 0 )then count = count + 1; end;
			local max = math.ceil( count / 2 ) * 60 + ( math.ceil( count / 2 ) * 5 ) - _G[ this:GetName() .. "Page" .. p .. "ScrollFrameContainer" ]:GetHeight() + 10;
			if( max < 0 )then max = 0; end;
			_G[ this:GetName() .. "Page" .. p .. "ScrollFrameScrollBar" ]:SetMinMaxValues( 0, max );
		end;
		SB.events.Placed = true;
	end;
end;

function SB.events.BookOnUpdate( this, elapsedTime )
	local main = GetTpExp();
	_G[ this:GetName() .. "TP" ].Caption = "Очки таланта: " .. MLib.ThSeparator( main );
	_, main = GetPlayerExpDebt();
	_G[ this:GetName() .. "TPDebt" ].Caption = "Долг таланта: " .. MLib.ThSeparator( main );

	if( SB.Inited == true )then
		local x, y = this:GetPos();
		SBVariables.Frame = {
			["X"] = x,
			["Y"] = y,
		};
	end;
end;

function SB.events.PageOnShow( this )
	--this:SetMinMaxValues( 0, max );
end;

function SB.events.OnValueChanged( this )
	local min, max = this:GetMinMaxValues()
	
	_G[ this:GetName() .. "ScrollDownButton" ]:Enable();
	_G[ this:GetName() .. "ScrollUpButton" ]:Enable();

	if this:GetValue() == min then
		_G[ this:GetName() .. "ScrollUpButton" ]:Disable()
	end
	if this:GetValue() == max then
		_G[ this:GetName() .. "ScrollDownButton" ]:Disable()
	end
	local skill = _G[ this:GetParent():GetName() .. "Container" .. "Skill1" ];
	skill:ClearAllAnchors();
	skill:SetAnchor( "TOPLEFT", "TOPLEFT", "$parent", 5, -( this:GetValue() ) );
end;

function SB.events.OnScroll( this, delta )
	if( delta > 0 )then
		this:SetValue( this:GetValue() - 2 );
	elseif( delta < 0 )then
		this:SetValue( this:GetValue() + 2 );
	end;
end;

function SB.events.OnScroll( this, delta )
end;

function SB.events.SkillOnEnter( this )
	GameTooltip:ClearAllAnchors();
	GameTooltip:SetOwner( this, "ANCHOR_RIGHT", 10, 0 );
	GameTooltip:SetSkillItem( this.Page, this.Index );
	GameTooltip:AddSeparator();
	GameTooltip:AddLine( "GUID: " .. GetSkillHyperLink( this.Page, this.Index ):match( "^|H.-:([0-9a-f]+)" ) );
end;

function SB.events.OnClick( this, key )
	if( key == "LBUTTON" )then
		if( IsShiftKeyDown() ) then
			ChatFrameEditBox:Show();
			ChatFrameEditBox:SetFocus();
			ChatEdit_AddItemLink( GetSkillHyperLink( this:GetParent().Page, this:GetParent().Index ) );
		elseif( IsCtrlKeyDown() ) then
			local _SkillName, _SkillLV, _IconPath, _Mode, _PLV, _PPoint, _PTotalPoint, _EnableToLV, _bLearned = GetSkillDetail( this:GetParent().Page, this:GetParent().Index );
			MNumberInputDialog:ClearAllAnchors();
			MNumberInputDialog:SetAnchor( "TOPLEFT", "BOTTOMLEFT", this, 0, 0 );
			MNumberInputDialog.MinValue = 1;
			MNumberInputDialog.MaxValue = 95;
			MNumberInputDialog.Value = _PLV;
			MNumberInputDialog.page = this:GetParent().Page;
			MNumberInputDialog.index = this:GetParent().Index;

			MNumberInputDialog:Show();
			MNumberInputDialogEdt1:SetFocus();
			MNumberInputDialog.OkFunc = function( this )
				--local guid = MLib.itemID( GetSkillHyperLink( this.page, this.index ) );
				local guid = GetSkillHyperLink( this.page, this.index ):match( "^|H.-:([0-9a-f]+)" );
				local pattern = "|Hskill:%s %s|h|cff8080ff[%s%s]|r|h";
				local _SkillName, _SkillLV, _IconPath, _Mode, _PLV, _PPoint, _PTotalPoint, _EnableToLV, _bLearned = GetSkillDetail( this.page, this.index );
				ChatFrameEditBox:Show();
				ChatFrameEditBox:SetFocus();
				local plus = "";
				if( this.Value > 1 )then plus = "+" .. this.Value; end;
				ChatEdit_AddItemLink( pattern:format( guid, this.Value, _SkillName, plus ) );
			end;
		else
			UseSkill( this:GetParent().Page, this:GetParent().Index );
		end;
	end;
end;

function SB.events.PageOnUpdate( this, elapsedTime )
	if( this:IsVisible() )then
		for n = 1, GetNumSkill( this:GetID() ) do
			local skill = this:GetName() .. "ScrollFrameContainer" .. "Skill";
			if( _G[ skill .. n ]:IsVisible() )then SB.events.PaintSkillButton( skill .. n, this:GetID(), n ); end;
		end;
	end;
end;

function SB.events.AIClick( this )
	local button = this:GetParent():GetParent();
	local id = button.Page .. ":" .. button.Index;
	local ntex = this:GetNormalTexture();
	local ptex = this:GetPushedTexture();
	--SB.Message( id );
	if( SBVariables.AI[ UnitClassToken( "player" ) ] == nil )then SBVariables.AI[ UnitClassToken( "player" ) ] = {}; end;
	if( SBVariables.AI[ UnitClassToken( "player" ) ][ id ] == nil )then
		SBVariables.AI[ UnitClassToken( "player" ) ][ id ] = true;
		ntex:SetTexture( "interface/addons/mskillbook/texture/checked" );
		ptex:SetTexture( "interface/addons/mskillbook/texture/checked" );
	else
		SBVariables.AI[ UnitClassToken( "player" ) ][ id ] = nil;
		ntex:SetTexture( "interface/addons/mskillbook/texture/unchecked" );
		ptex:SetTexture( "interface/addons/mskillbook/texture/unchecked" );
	end;
end;

function SB.events.AIHint( this )
	local button = this:GetParent():GetParent();
	local id = button.Page .. ":" .. button.Index;
	if( SBVariables.AI[ UnitClassToken( "player" ) ] == nil )then SBVariables.AI[ UnitClassToken( "player" ) ] = {}; end;
	MLib.TT.Init( this, SB.Name .. " " .. SB.Version, 300, "ANCHOR_TOPLEFT", 0, 0 );
	MLib.TT.LineEx( "Автоувеличение уровня ", SBVariables.AI[ UnitClassToken( "player" ) ][ id ] ~=nil, MLib.YESPattern:format( "включено" ), MLib.NOPattern:format( "выключено" ) );
end;

-- /run dofile("interface/addons/mskillbook/code/events.lua");